/*
THE COMPUTER CODE CONTAINED HEREIN IS THE SOLE PROPERTY OF PARALLAX
SOFTWARE CORPORATION ("PARALLAX").  PARALLAX, IN DISTRIBUTING THE CODE TO
END-USERS, AND SUBJECT TO ALL OF THE TERMS AND CONDITIONS HEREIN, GRANTS A
ROYALTY-FREE, PERPETUAL LICENSE TO SUCH END-USERS FOR USE BY SUCH END-USERS
IN USING, DISPLAYING,  AND CREATING DERIVATIVE WORKS THEREOF, SO LONG AS
SUCH USE, DISPLAY OR CREATION IS FOR NON-COMMERCIAL, ROYALTY OR REVENUE
FREE PURPOSES.  IN NO EVENT SHALL THE END-USER USE THE COMPUTER CODE
CONTAINED HEREIN FOR REVENUE-BEARING PURPOSES.  THE END-USER UNDERSTANDS
AND AGREES TO THE TERMS HEREIN AND ACCEPTS THE SAME BY USE OF THIS FILE.
COPYRIGHT 1993-1999 PARALLAX SOFTWARE CORPORATION.  ALL RIGHTS RESERVED.
*/

#ifndef _OMEGA_H
#define _OMEGA_H

#define OMEGA_MULTI_LIFELEFT    (I2X (1)/6)

//	Change the following constants to affect the look of the omega cannon.
//	Changing these constants will not affect the damage done.
//	WARNING: If you change DESIRED_OMEGA_DIST and MAX_OMEGA_BLOBS, you don't merely change the look of the cannon,
//	you change its range.  If you decrease DESIRED_OMEGA_DIST, you decrease how far the gun can fire.
#define	MIN_OMEGA_BLOB_DIST		I2X (3)					//	At least this distance between blobs, unless doing so would violate MIN_OMEGA_BLOBS
#define	MAX_OMEGA_BLOB_DIST		I2X (5)					//	This is the desired distance between blobs.  For distances > MIN_OMEGA_BLOBS*DESIRED_OMEGA_DIST, but not very large, this will apply.
#define	MIN_OMEGA_BLOBS			3						//	No matter how close the obstruction, at this many blobs created.
#define	MAX_OMEGA_BLOBS			16						//	No matter how far away the obstruction, this is the maximum number of blobs.

//	Additionally, several constants which apply to homing gameData.objData.objects in general control the behavior of the Omega Cannon.
//	They are defined in fireweapon.h.  They are copied here for reference.  These values are valid on 1/10/96:
//	If you want the Omega Cannon view cone to be different than the Homing Missile viewcone, contact MK to make the change.
//	 (Unless you are a programmer, in which case, do it yourself!)

void DoOmegaStuff (CObject *pParentObj, CFixVector *vFiringPos, CObject *pWeaponObj);
int32_t UpdateOmegaLightnings (CObject *pParentObj, CObject *pTargetObj);
void DestroyOmegaLightnings (int16_t nObject);
void SetMaxOmegaCharge (void);

#define MAX_OMEGA_CHARGE (gameStates.app.bHaveExtraGameInfo [IsMultiGame] ? gameData.omegaData.xMaxCharge : DEFAULT_MAX_OMEGA_CHARGE)

#endif /* _OMEGA_H */
